using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace Forum
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			dt = GetTable();
			this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
			this.gridControl1.SaveCellInfo += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
			this.gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryColCount);
			this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryRowCount);
			this.gridControl1.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(gridControl1_PrepareViewStyleInfo);
			this.gridControl1.ResetVolatileData();
			
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(16, 16);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(352, 272);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(128, 304);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Print Preview";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(384, 342);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dt;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			
			this.gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(1,1,1,3));
			this.gridControl1.Model.Rows.Hidden[0] = true;
			this.gridControl1.Model.Rows.HeaderCount = 2;
			this.gridControl1.Model.Rows.FrozenCount = 2;
            this.gridControl1.Model.RowHeights[1] = 500;
            this.gridControl1.Model.RowHeights[2] = 32;
            this.gridControl1.Model.RowHeights.ResizeToFit(GridRangeInfo.Rows(3, this.gridControl1.RowCount));
		}


		private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 1)
			{
				e.Style.CellValue = dt.Rows[e.RowIndex-1][e.ColIndex-1];
			}
			e.Handled = true;
		}

		int nCols;
		int nRows;
		private DataTable GetTable()
		{
			nCols = 10;
			nRows = 150;
			DataTable dt = new DataTable("table");
			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = string.Format("rowwwwwwwwwwwwwwwww{0} col{1}", i, j);
					
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = nCols;
			e.Handled = true;
		}

		private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = nRows;
			e.Handled = true;
		}
		
		private void gridControl1_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
				dt.Rows[e.RowIndex-1][e.ColIndex-1] = e.Style.CellValue.ToString();
			e.Handled = true;
		}

		private void gridControl1_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
            string str = "";
            if(e.RowIndex == 1 && e.ColIndex == 1)
            {
//                for(int i=0; i<5000;i++)
//                    str += i;
                e.Style.CellValue = "Some long text";                
            }	
			e.Style.WrapText = true;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//this.gridControl1.Model.ColWidths.ResizeToFit(GridRangeInfo.Rows(1,2));
            //this.gridControl1.Model.RowHeights.ResizeToFit(GridRangeInfo.Rows(3, this.gridControl1.RowCount));
			//this.gridControl1.Model.Rows.Hidden[1] = true;
            this.gridControl1.Model.Rows.Hidden[1] = false;
			this.gridControl1.Model.Rows.FrozenCount = 2;
			if (gridControl1 != null)
			{
				try 
				{
					GridPrintDocument pd = new GridPrintDocument(gridControl1, true); 
                    pd.DefaultPageSettings.Landscape = true;
                    pd.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.pd_PrintPage);

					PrintPreviewDialog dlg = new PrintPreviewDialog() ;
					dlg.Document = pd;
                    dlg.PrintPreviewControl.Zoom = 1;	
					dlg.ShowDialog();
				} 
				catch(Exception ex) 
				{ 
					MessageBox.Show("An error occurred attempting to preview the file to print - " + ex.Message);
				}
			}
			this.gridControl1.Model.Rows.Hidden[1] = false;
			this.gridControl1.Model.Rows.FrozenCount = 2;
		}

        private int m_pagenum = 0;
        private void pd_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            m_pagenum++;

            //FIXIT: this is not working as well.
            //Only from 2nd page onwards I want to hide Row1 but still show Row2.
            if(m_pagenum > 1) 
            {
                gridControl1.Model.Rows.Hidden[1] = true;
                gridControl1.Model.Rows.FrozenCount = 2;

            }
            
        }
	}
}
